--[[core.register_node("forestos:blueberry_shrub", {
		description = "Blueberry Shrub",
		drawtype = "plantlike",
		waving = 1,
		tiles = {"forests_blueberry_shrub.png"},
		paramtype = "light",
		sunlight_propagates = true,

		walkable = false,
		buildable_to = true,
		groups = {snappy = 3, flammable = 3, flora = 1, fuel = 1,
			attached_node = 1, not_in_creative_inventory = 1, fuel = 2},
		drop = "forestos_blueberry_shrub",
		sounds = default.node_sound_leaves_defaults(),
		selection_box = {
			type = "fixed",
			fixed = {-0.5, -0.5, -0.5, 0.5, -5/16, 0.5},
		},
	})
    
    
]]--
local S = biome_lib.intllib

bushes_classic = {}

bushes_classic.bushes = {
    "strawberry",
	"blackberry",
	"blueberry",
	"raspberry",
	"gooseberry",
	"mixed_berry"
}

bushes_classic.bushes_descriptions = {
    "Strawberry",
	"Blackberry",
	"Blueberry",
	"Raspberry",
	"Gooseberry",
	"Mixed Berry"
}

bushes_classic.spawn_list = {}

local modpath = minetest.get_modpath('bushes_classic')

dofile(modpath..'/nodes.lua')

biome_lib:spawn_on_surfaces({
	spawn_delay = 3600,
	spawn_plants = bushes_classic.spawn_list,
	avoid_radius = 10,
	spawn_chance = 100,
	spawn_surfaces = {
		"default:dirt_with_grass",
		"woodsoils:dirt_with_leaves_1",
		"woodsoils:grass_with_leaves_1",
		"woodsoils:grass_with_leaves_2",
		"farming:soil",
		"farming:soil_wet"
	},
	avoid_nodes = {"group:bush"},
	seed_diff = 545342534, -- chosen by a fair mashing of the keyboard - guaranteed to be random :P
	plantlife_limit = -0.1,
	light_min = 10,
	temp_min = 0.15, -- approx 20C
	temp_max = -0.15, -- approx 35C
	humidity_min = 0, -- 50% RH
	humidity_max = -1, -- 100% RH
})

minetest.register_alias("bushes:basket_pies", "bushes:basket_strawberry")

print(S("[Bushes] Loaded."))
